# Brandfolder Drupal Integration
-------------------------------------------------------------------------------
![CircleCI](https://img.shields.io/circleci/build/github/brandfolder/integration-drupal?token=94d3945b6680f1ca5e786886ac94757e49c5136b)

This module allows you to manage images using the Brandfolder
(https://brandfolder.com) Digital Asset Management system and reference those
images from your Drupal site. It creates an additional file system in Drupal,
similar to the "public" and "private" file systems, but the Brandfolder file
system is read-only by design. The intended workflow is to upload and curate
images in your Brandfolder portal and then use this module to associate those
images with Drupal content via image fields.


# Dependencies
-------------------------------------------------------------------------------
 - An active Brandfolder account (see https://brandfolder.com) with "Smart CDN"
functionality enabled.
 - The Brandfolder PHP SDK/library (see below).

# Installation
-------------------------------------------------------------------------------
Install the module as you would install any other Drupal module. Use the
[Composer Manager](https://www.drupal.org/project/composer_manager) module to
ensure that the
[Brandfolder PHP library](https://github.com/orientier/brandfolder-api-php) is
correctly installed as well.
@todo: Add more info and alternative options.

# Initial Setup
-------------------------------------------------------------------------------
1. Log in to your Brandfolder account as an administrator
2. Navigate to "My Profile" > "Integrations"
3. In the "API Keys" section, copy the key for the Brandfolder organization you
wish to integrate.
4. Visit /admin/config/media/brandfolder/settings on your Drupal site
5. Enter the API key and save the settings form.

You can also set the key in your site's settings.php file
(e.g. sites/default/settings.php) if desired.
$conf['brandfolder_api_key'] = 'YOUR API KEY';

# Configuration
-------------------------------------------------------------------------------
Add a field of type Image and set the "File system" to "Brandfolder" in the
"Field Settings" tab.

That field will then function differently than a normal image field.
Specifically:
 - When adding files to a Drupal entity via that field, users will be unable to
   upload new files; rather, they will be presented with a library of
   Brandfolder images from which to choose.
 - When users select a Brandfolder image and save the Drupal entity, Drupal will
   associate the selected Brandfolder image with that Drupal entity, but will
   not copy the file into your web server's file system.
 - When displaying the image, Drupal will deliver an image tag with a URL
   from Brandfolder's "Smart CDN." The Brandfolder module also supports Drupal
   image styles consisting of scaling and/or cropping effects, and does so
   without needing to copy images from Brandfolder to Drupal. Images are
   transformed using Brandfolder's URL transformation API rather than Drupal's
   image toolkit.

# Acknowledgements
-------------------------------------------------------------------------------
The Amazon S3 File System module (https://www.drupal.org/project/s3fs) served
as a great reference in terms of defining a custom file stream wrapper, etc.
